--!parent
--!encoding=utf-8

--****************************************************************************
-- @package Qt OOP API
-- @file Event Callback Detacher
-- @version 0.2
-- @author Valentin Schmidt
--****************************************************************************

global $

property _sender
property _method
property _receiver
property _signal

----------------------------------------
-- @constructor
----------------------------------------
on new (me, sender, method, receiver,   signal)

	me._sender = sender
	me._method = method
	me._receiver = receiver
	
	me._signal = signal
	return me
end

----------------------------------------
-- use 1 ms single-shot timeout to create a new thread
-- so scripting errors in callbacks don't fail silently
----------------------------------------
on _detach (me, widgetID, v1, v2,  v3)
	$.detacher.detach(#_call, me, [v1,v2,  v3])
end

----------------------------------------
-- we are detached from original thread, now handle signal
----------------------------------------
on _call (me, args)
	call(me._method, me._receiver, me._sender, args[1], args[2],  args[3])
	
--	case paramCount() of
--		1: call(me._method, me._receiver, me._sender)
--		2: call(me._method, me._receiver, me._sender, param(2))
--		3: call(me._method, me._receiver, me._sender, param(2), param(3))
--		4: call(me._method, me._receiver, me._sender, param(2), param(3), param(4))
--		otherwise: call(t[1], t[2], args[1], args[2], args[3], args[4], args[5])
--	end case
end


------------------------------------------
---- Using 1 ms single-shot timeouts to create new threads,
---- so scripting errors in callbacks don't fail silently.
---- @callback
------------------------------------------
--on _detach (me, signal, id,v1,v2)
--  $.detacher.detach(#_call, me, [signal, id,v1,v2])
--end
--
------------------------------------------
---- We are detached from original thread, now handle signal
---- @callback
------------------------------------------
--on _call (me, args) -- signal, id,v1,v2
--  listeners = me._listeners[args[1]]
--  if not voidP(listeners) then
--    repeat with l in listeners
--      call(l[2],l[1], args[2],args[3],args[4])
--    end repeat
--  end if
--end
