--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #InputDialog
  me.ancestor = $.include($.Qt.libDir&"classes/iDialog.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iDialog.ls").new()
	obj._class = #InputDialog
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- setCancelButtonText (string)
on setCancelButtonText (me,p1)
  $.Qt._qx.callWidget(me._id,#setCancelButtonText,p1)
end

-- setDecimals (int)
on setDecimals (me,p1)
  $.Qt._qx.callWidget(me._id,#setDecimals,p1)
end

-- setInputMode (int)
on setInputMode (me,p1)
  $.Qt._qx.callWidget(me._id,#setInputMode,p1)
end

-- setLabelText (string)
on setLabelText (me,p1)
  $.Qt._qx.callWidget(me._id,#setLabelText,p1)
end

-- setMaximum (int|float)
on setMaximum (me,p1)
  $.Qt._qx.callWidget(me._id,#setMaximum,p1)
end

-- setMinimum (int|float)
on setMinimum (me,p1)
  $.Qt._qx.callWidget(me._id,#setMinimum,p1)
end

-- setOkButtonText (string)
on setOkButtonText (me,p1)
  $.Qt._qx.callWidget(me._id,#setOkButtonText,p1)
end

-- setOption (int,bool)
on setOption (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setOption,p1,p2)
end

-- setRange (int|float,int|float)
on setRange (me,p1)
  $.Qt._qx.callWidget(me._id,#setRange,p1)
end

-- setStep (int)
on setStep (me,p1)
  $.Qt._qx.callWidget(me._id,#setStep,p1)
end

-- setTextEchoMode (int)
on setTextEchoMode (me,p1)
  $.Qt._qx.callWidget(me._id,#setTextEchoMode,p1)
end

-- setValue (int|float|string)
on setValue (me,p1)
  $.Qt._qx.callWidget(me._id,#setValue,p1)
end

-- value () -> int|float|string
on value (me)
  return $.Qt._qx.callWidget(me._id,#value)
end

----------------------------------------
-- STATIC
----------------------------------------

-- getText (WidgetID,string,string,int,string) -> string
on getText (scr,p1,p2,p3,p4,p5)
  if ilk(p1)=#instance then p1 = p1._id
  return $.Qt._qx.callWidget(#InputDialog,#getText,p1,p2,p3,p4,p5)
end

----------------------------------------
-- SIGNALS
----------------------------------------

-- textValueChanged -> string
on textValueChanged(me,id,p1)
  me._detach(#textValueChanged,me,p1)
end

-- textValueSelected -> string
on textValueSelected(me,id,p1)
  me._detach(#textValueSelected,me,p1)
end
