--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #Action
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newObject(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #Action
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- data () -> bytearray|string
on data (me)
  return $.Qt._qx.callObject(me._id,#data)
end

-- getFont () -> FontID
on getFont (me)
  obj = $.Qt.Font._make($.Qt._qx.callObject(me._id,#getFont))
  me._children.add(obj)
  return obj
end

-- hasIcon () -> bool
on hasIcon (me)
  return $.Qt._qx.callObject(me._id,#hasIcon)
end

-- isChecked () -> bool
on isChecked (me)
  return $.Qt._qx.callObject(me._id,#isChecked)
end

-- objectName () -> string
on objectName (me)
  return $.Qt._qx.callObject(me._id,#objectName)
end

-- setCheckable (bool)
on setCheckable (me,p1)
  $.Qt._qx.callObject(me._id,#setCheckable,p1)
end

-- setChecked (bool)
on setChecked (me,p1)
  $.Qt._qx.callObject(me._id,#setChecked,p1)
end

-- setData (bytearray|string)
on setData (me,p1)
  $.Qt._qx.callObject(me._id,#setData,p1)
end

-- setEnabled (bool)
on setEnabled (me,p1)
  $.Qt._qx.callObject(me._id,#setEnabled,p1)
end

-- setFont (FontID|string)+(string,int|float,*int,bool)
on setFont (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callObject(me._id,#setFont,p1)
end

-- setIcon (image|string)
on setIcon (me,p1)
  $.Qt._qx.callObject(me._id,#setIcon,p1)
end

-- setObjectName (string)
on setObjectName (me,p1)
  $.Qt._qx.callObject(me._id,#setObjectName,p1)
end

-- setShortcut (string)
on setShortcut (me,p1)
  $.Qt._qx.callObject(me._id,#setShortcut,p1)
end

-- setShortcutContext (int)
on setShortcutContext (me,p1)
  $.Qt._qx.callObject(me._id,#setShortcutContext,p1)
end

-- TODO
-- setStatusTip (string)
on setStatusTip (me,p1)
  $.Qt._qx.callObject(me._id,#setStatusTip,p1)
end

-- setText (string)
on setText (me,p1)
  $.Qt._qx.callObject(me._id,#setText,p1)
end

-- setVisible (bool)
on setVisible (me,p1)
  $.Qt._qx.callObject(me._id,#setVisible,p1)
end

-- text () -> string
on text (me)
  return $.Qt._qx.callObject(me._id,#text)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- toggled -> bool
on toggled(me,id,p1)
  me._detach(#toggled,me,p1)
end

-- triggered
on triggered(me,id)
  me._detach(#triggered,me)
end
