--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (string)
on new (me,p1)
  me._class = #Dir
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  me._id = $.Qt._qx.newObject(me._class,VOID,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #Dir
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- absolutePath () -> string
on absolutePath (me)
  return $.Qt._qx.callObject(me._id,#absolutePath)
end

-- dirName () -> string
on dirName (me)
  return $.Qt._qx.callObject(me._id,#dirName)
end

-- entryList (*int filters, int sort) -> list entries
on entryList (me,p1,p2)
  return $.Qt._qx.callObject(me._id,#entryList,p1,p2)
end

-- exists () -> bool
on exists (me)
  return $.Qt._qx.callObject(me._id,#exists)
end

-- remove (string fileName) -> bool
on remove (me,p1)
  return $.Qt._qx.callObject(me._id,#remove,p1)
end

-- rename (sring oldName, string newName) -> bool
on rename (me,p1,p2)
  return $.Qt._qx.callObject(me._id,#rename,p1,p2)
end

----------------------------------------
-- STATIC
----------------------------------------

-- addSearchPath (string,string)
on addSearchPath (scr,p1,p2)
  $.Qt._qx.callObject(#Dir,#addSearchPath,p1,p2)
end

-- currentPath () -> string
on currentPath (scr)
  return $.Qt._qx.callObject(#Dir,#currentPath)
end

-- homePath () -> string
on homePath (scr)
  return $.Qt._qx.callObject(#Dir,#homePath)
end

-- rootPath () -> string
on rootPath (scr)
  return $.Qt._qx.callObject(#Dir,#rootPath)
end

-- setCurrent (string)
on setCurrent (scr,p1)
  $.Qt._qx.callObject(#Dir,#setCurrent,p1)
end

-- setSearchPaths (string,list)
on setSearchPaths (scr,p1,p2)
  $.Qt._qx.callObject(#Dir,#setSearchPaths,p1,p2)
end

-- tempPath () -> string
on tempPath (scr)
  return $.Qt._qx.callObject(#Dir,#tempPath)
end

-- toNativeSeparators (string) -> string
on toNativeSeparators (scr,p1)
  return $.Qt._qx.callObject(#Dir,#toNativeSeparators,p1)
end

----------------------------------------
-- SIGNALS
----------------------------------------
