--!parent
--!encoding=utf-8

--****************************************************************************
-- @package	 Qt OOP API
-- @version		0.2
-- @requires	Xtra("QtWidgets")
-- @author	 	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
	me._class = #TcpServer
	me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	if ilk(p1)=#instance then
		p1._children.add(me)
		p1 = p1._id
	end if
	me._id = $.Qt._qx.newObject(me._class,p1)
	return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #TcpServer
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

--ACTIONS:
---close ()
---errorString () -> string
---hasPendingConnections () -> bool
---isListening () -> bool
---listen (*string|void, int) -> bool
---nextPendingConnection () -> int TcpSocketID
---setMaxPendingConnections (int)
---waitForNewConnection (*int msec) -> bool
--
--SIGNALS:
--#newConnection

-- close ()
on close (me)
	$.Qt._qx.callObject(me._id,#close)
end

-- errorString () -> string
on errorString (me)
	return $.Qt._qx.callObject(me._id,#errorString)
end

-- hasPendingConnections () -> bool
on hasPendingConnections (me)
	return $.Qt._qx.callObject(me._id,#hasPendingConnections)
end

-- isListening () -> bool
on isListening (me)
	return $.Qt._qx.callObject(me._id,#isListening)
end

-- listen () -> bool
on listen (me,p1,p2)
	return $.Qt._qx.callObject(me._id,#listen,p1,p2)
end

-- nextPendingConnection () -> TcpSocketID
on nextPendingConnection (me)
	id = $.Qt._qx.callObject(me._id,#nextPendingConnection)
	obj = $.Qt.TcpSocket._make(id)
	--me._children.add(obj)
	return obj
end

-- setMaxPendingConnections (int)
on setMaxPendingConnections (me,p1)
	$.Qt._qx.callObject(me._id,#setMaxPendingConnections,p1)
end

-- waitForNewConnection (*int msec) -> bool
on waitForNewConnection (me,p1)
	return $.Qt._qx.callObject(me._id,#waitForNewConnection,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- newConnection
on newConnection(me,id)
	me._detach(#newConnection,me)
end
