--!parent
--!encoding=utf-8

--****************************************************************************
-- @package	 Qt OOP API
-- @version		0.2
-- @requires	Xtra("QtWidgets")
-- @author	 	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
	me._class = #TcpSocket
	me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	if ilk(p1)=#instance then
		p1._children.add(me)
		p1 = p1._id
	end if
	me._id = $.Qt._qx.newObject(me._class,p1)
	return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #TcpSocket
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- abort ()
on abort (me)
	$.Qt._qx.callObject(me._id,#abort)
end

-- atEnd () -> bool
on atEnd (me)
	return $.Qt._qx.callObject(me._id,#atEnd)
end

-- bytesAvailable () -> int
on bytesAvailable (me)
	return $.Qt._qx.callObject(me._id,#bytesAvailable)
end

-- bytesToWrite () -> int
on bytesToWrite (me)
	return $.Qt._qx.callObject(me._id,#bytesToWrite)
end

-- canReadLine () -> bool
on canReadLine (me)
	return $.Qt._qx.callObject(me._id,#canReadLine)
end

-- close ()
on close (me)
	$.Qt._qx.callObject(me._id,#close)
end

-- connectToHost (string,int)
on connectToHost (me,p1,p2)
	$.Qt._qx.callObject(me._id,#connectToHost,p1,p2)
end

-- disconnectFromHost ()
on disconnectFromHost (me)
	$.Qt._qx.callObject(me._id,#disconnectFromHost)
end

-- flush () -> bool
on flush (me)
	return $.Qt._qx.callObject(me._id,#flush)
end

-- getError () -> int
on getError (me)
	return $.Qt._qx.callObject(me._id,#getError)
end

-- objectName () -> string
on objectName (me)
	return $.Qt._qx.callObject(me._id,#objectName)
end

-- read (int) -> bytearray|string
on read (me,p1)
	return $.Qt._qx.callObject(me._id,#read,p1)
end

-- readAll () -> bytearray|string
on readAll (me)
	return $.Qt._qx.callObject(me._id,#readAll)
end

-- readLine (int) -> bytearray|string
on readLine (me,p1)
	return $.Qt._qx.callObject(me._id,#readLine,p1)
end

-- setObjectName (string)
on setObjectName (me,p1)
	$.Qt._qx.callObject(me._id,#setObjectName,p1)
end

-- setReadBufferSize (int)
on setReadBufferSize (me,p1)
	$.Qt._qx.callObject(me._id,#setReadBufferSize,p1)
end

-- state () -> int
on state (me)
	return $.Qt._qx.callObject(me._id,#state)
end

-- waitForBytesWritten (*int) -> bool
on waitForBytesWritten (me,p1)
	return $.Qt._qx.callObject(me._id,#waitForBytesWritten,p1)
end

-- waitForConnected (*int) -> bool
on waitForConnected (me,p1)
	return $.Qt._qx.callObject(me._id,#waitForConnected,p1)
end

-- waitForDisconnected (*int) -> bool
on waitForDisconnected (me,p1)
	return $.Qt._qx.callObject(me._id,#waitForDisconnected,p1)
end

-- waitForReadyRead (*int) -> bool
on waitForReadyRead (me,p1)
	return $.Qt._qx.callObject(me._id,#waitForReadyRead,p1)
end

-- write (bytearray|string) -> int
on write (me,p1)
	return $.Qt._qx.callObject(me._id,#write,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- bytesWritten -> int
on bytesWritten(me,id,p1)
	me._detach(#bytesWritten,me,p1)
end

-- connected
on connected(me,id)
	me._detach(#connected,me)
end

-- disconnected
on disconnected(me,id)
	me._detach(#disconnected,me)
end

-- error -> int
on error(me,id,p1)
	me._detach(#error,me,p1)
end

-- hostFound
on hostFound(me,id)
	me._detach(#hostFound,me)
end

-- readyRead
on readyRead(me,id)
	me._detach(#readyRead,me)
end

-- stateChanged -> int
on stateChanged(me,id,p1)
	me._detach(#stateChanged,me,p1)
end
