--!parent
--!encoding=utf-8

--****************************************************************************
-- @package	 Qt OOP API
-- @version		0.3
-- @requires	Xtra("QtWidgets")
-- @author	 	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
on new (me,p1,p2)
	me._class = #ListWidget
	me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	if ilk(p1)=#instance then
		p1._children.add(me)
		p1 = p1._id
	end if
	if voidP(p2) then
		me._id = $.Qt._qx.newWidget(me._class,p1)
	else
		me._id = $.Qt._qx.newWidget(me._class,p1,p2)
	end if
	return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #ListWidget
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- addItem (string,*string|image)
--on addItem (me,p1,p2)
--	$.Qt._qx.callWidget(me._id,#addItem,p1,p2)
--end
-- addItem (ListWidgetItemID)
on addItem (me,p1)
	if ilk(p1)=#instance then p1 = p1._id
	$.Qt._qx.callWidget(me._id,#addItem,p1)
end

-- addItems (list labels)
on addItems (me,p1)
	$.Qt._qx.callWidget(me._id,#addItems,p1)
end

-- clear ()
on clear (me)
	$.Qt._qx.callWidget(me._id,#clear)
end

-- count () -> int
on count_ (me)
	return $.Qt._qx.callWidget(me._id,#count)
end

-- currentRow () -> int
on currentRow (me)
	return $.Qt._qx.callWidget(me._id,#currentRow)
end

-- iconSize () -> list widthAndHeight
on iconSize (me)
	return $.Qt._qx.callWidget(me._id,#iconSize)
end

-- insertItem (int,string,*string|image)
--on insertItem (me,p1,p2,p3)
--	$.Qt._qx.callWidget(me._id,#insertItem,p1,p2,p3)
--end
-- insertItem (int,ListWidgetItemID)
on insertItem (me,p1,p2)
	if ilk(p2)=#instance then p2 = p2._id
	$.Qt._qx.callWidget(me._id,#insertItem,p1,p2)
end

-- item (int row) -> string
--on item_ (me,p1)
--	return $.Qt._qx.callWidget(me._id,#item,p1)
--end
-- item (int row) -> ListWidgetItemID
on item_ (me,p1)
	obj = $.Qt.ListWidgetItem._make($.Qt._qx.callWidget(me._id,#item,p1))
	me._children.add(obj)
	return obj
end

-- itemAt (int,int) -> ListWidgetItemID
on itemAt (me,p1,p2)
	obj = $.Qt.ListWidgetItem._make($.Qt._qx.callWidget(me._id,#itemAt,p1,p2))
	me._children.add(obj)
	return obj
end

-- removeItem (int row) -- CUSTOM!
on removeItem (me,p1)
	$.Qt._qx.callWidget(me._id,#removeItem,p1)
end

-- takeItem (int row) -> int ListWidgetItemID
on takeItem (me,p1)
	obj = $.Qt.ListWidgetItem._make($.Qt._qx.callWidget(me._id,#takeItem,p1))
	return obj
end

-- row (int ListWidgetItemID) -> int row
on row (me,p1)
	if ilk(p1)=#instance then p1 = p1._id
	return $.Qt._qx.callWidget(me._id,#row,p1)
end

-- selectedItems () -> list ListWidgetItemIDs
on selectedItems (me)
	-- TODO: objects!
	return $.Qt._qx.callWidget(me._id,#selectedItems)
end

-- setCurrentItem (ListWidgetItemID)
on setCurrentItem (me,p1)
	if ilk(p1)=#instance then p1 = p1._id
	$.Qt._qx.callWidget(me._id,#setCurrentItem,p1)
end

-- setDefaultDropAction (int)
on setDefaultDropAction (me,p1)
	$.Qt._qx.callWidget(me._id,#setDefaultDropAction,p1)
end

-- setCurrentRow (int)
on setCurrentRow (me,p1)
	$.Qt._qx.callWidget(me._id,#setCurrentRow,p1)
end

-- setDragDropMode (int)
on setDragDropMode (me,p1)
	$.Qt._qx.callWidget(me._id,#setDragDropMode,p1)
end

-- setDragEnabled (bool)
on setDragEnabled (me,p1)
	$.Qt._qx.callWidget(me._id,#setDragEnabled,p1)
end

-- setDropIndicatorShown (bool)
on setDropIndicatorShown (me,p1)
	$.Qt._qx.callWidget(me._id,#setDropIndicatorShown,p1)
end

-- setFrameShape (int)
on setFrameShape (me,p1)
  $.Qt._qx.callWidget(me._id,#setFrameShape,p1)
end

-- setIconSize (int,int)
on setIconSize (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#setIconSize,p1,p2)
end

-- setItemWidget (ListWidgetItemID, WidgetID)
on setItemWidget (me,p1,p2)
	if ilk(p1)=#instance then p1 = p1._id
	if ilk(p2)=#instance then p2 = p2._id
	$.Qt._qx.callWidget(me._id,#setItemWidget,p1,p2)
end

-- setRawDropMode (bool)
on setRawDropMode (me,p1)
	$.Qt._qx.callWidget(me._id,#setRawDropMode,p1)
end

-- setResizeMode (int)
on setResizeMode (me,p1)
	$.Qt._qx.callWidget(me._id,#setResizeMode,p1)
end

-- setViewMode (int)
on setViewMode (me,p1)
	$.Qt._qx.callWidget(me._id,#setViewMode,p1)
end

-- setSortingEnabled (bool)
on setSortingEnabled (me,p1)
	$.Qt._qx.callWidget(me._id,#setSortingEnabled,p1)
end

-- sortingEnabled () -> bool
on sortingEnabled (me)
	return $.Qt._qx.callWidget(me._id,#sortingEnabled)
end

-- sortItems ()
on sortItems (me)
	$.Qt._qx.callWidget(me._id,#sortItems)
end

-- visualItemRect (int) -> rect
on visualItemRect (me,p1)
	if ilk(p1)=#instance then p1 = p1._id
	return $.Qt._qx.callWidget(me._id,#visualItemRect,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- activated -> int
on activated(me,id,p1)
	me._detach(#activated,me,p1)
end

-- clicked -> int
on clicked(me,id,p1)
	me._detach(#clicked,me,p1)
end

-- currentItemChanged -> int,int
on currentItemChanged(me,id,p1,p2)
	put "currentItemChanged", p1,p2
	p1 = $.Qt.ListWidgetItem._make(p1)
	p2 = $.Qt.ListWidgetItem._make(p2)
	me._detach(#currentItemChanged,me,p1,p2)
end

-- currentRowChanged -> int
on currentRowChanged(me,id,p1)
	me._detach(#currentRowChanged,me,p1)
end

-- doubleClicked -> int
on doubleClicked(me,id,p1)
	me._detach(#doubleClicked,me,p1)
end

-- entered -> int
on entered(me,id,p1)
	me._detach(#entered,me,p1)
end

-- pressed -> int
on pressed(me,id,p1)
	me._detach(#pressed,me,p1)
end

-- rowInserted -> int
on rowInserted(me,id,p1)
	me._detach(#rowInserted,me,p1)
end

-- rowMoved -> int,int
on rowMoved(me,id,p1,p2)
	me._detach(#rowMoved,me,p1,p2)
end

-- rowRemoved -> int
on rowRemoved(me,id,p1)
	me._detach(#rowRemoved,me,p1)
end
