--!parent
--!encoding=utf-8

--****************************************************************************
-- @package	 Qt OOP API
-- @version		0.2
-- @requires	Xtra("QtWidgets")
-- @author	 	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
on new (me,p1,p2)
	me._class = #TreeView
	me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	if ilk(p1)=#instance then
		p1._children.add(me)
		p1 = p1._id
	end if
	if voidP(p2) then
		me._id = $.Qt._qx.newWidget(me._class,p1)
	else
		me._id = $.Qt._qx.newWidget(me._class,p1,p2)
	end if
	return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #TreeView
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- currentPath () -> string path
on currentPath (me)
	return $.Qt._qx.callWidget(me._id,#currentPath)
end

-- keyboardSearch ()
on keyboardSearch (me)
	$.Qt._qx.callWidget(me._id,#keyboardSearch)
end

-- reset ()
on reset (me)
	$.Qt._qx.callWidget(me._id,#reset)
end

-- selectPath (string path)
on selectPath (me,p1)
	$.Qt._qx.callWidget(me._id,#selectPath,p1)
end

-- scrollTo (string,*int)
on scrollTo (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#scrollTo,p1,p2)
end

-- selectAll ()
on selectAll (me)
	$.Qt._qx.callWidget(me._id,#selectAll)
end

-- setAlternatingRowColors (bool)
on setAlternatingRowColors (me,p1)
	$.Qt._qx.callWidget(me._id,#setAlternatingRowColors,p1)
end

-- setColumnHidden (int,bool)
on setColumnHidden (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#setColumnHidden,p1,p2)
end

--setColumnWidth(int column, int width)
on setColumnWidth (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#setColumnWidth,p1,p2)
end

-- setExpanded(string path, bool expanded) ; NEW
on setExpanded (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#setExpanded,p1,p2)
end

-- setFilter (int filter)
on setFilter (me,p1)
	$.Qt._qx.callWidget(me._id,#setFilter,p1)
end

-- setHeaderHidden (bool)
on setHeaderHidden (me,p1)
	$.Qt._qx.callWidget(me._id,#setHeaderHidden,p1)
end

-- setRoot (string path, *readOnlyFlag)
on setRoot (me,p1,p2)
	if voidP(p2) then
		$.Qt._qx.callWidget(me._id,#setRoot,p1)
	else
		$.Qt._qx.callWidget(me._id,#setRoot,p1,p2)
	end if
end

-- setRootIndex (string path)
--on setRootIndex (me,p1)
--  $.Qt._qx.callWidget(me._id,#setRootIndex,p1)
--end

-- setSortingEnabled (bool)
on setSortingEnabled (me,p1)
	$.Qt._qx.callWidget(me._id,#setSortingEnabled,p1)
end

-- sortByColumn (int,*int)
on sortByColumn (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#sortByColumn,p1,p2)
end

-- setRawDropMode (bool)
on setRawDropMode (me,p1)
	$.Qt._qx.callWidget(me._id,#setRawDropMode,p1)
end

-- setDragDropMode (int)
on setDragDropMode (me,p1)
	$.Qt._qx.callWidget(me._id,#setDragDropMode,p1)
end

-- setDropIndicatorShown (bool)
on setDropIndicatorShown (me,p1)
	$.Qt._qx.callWidget(me._id,#setDropIndicatorShown,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- activated -> string
on activated(me,id,p1)
	me._detach(#activated,me,p1)
end

-- clicked -> string
on clicked(me,id,p1)
	me._detach(#clicked,me,p1)
end

-- collapsed
on collapsed(me,id)
	me._detach(#collapsed,me)
end

-- doubleClicked -> string
on doubleClicked(me,id,p1)
	me._detach(#doubleClicked,me,p1)
end

-- entered -> string
on entered(me,id,p1)
	me._detach(#entered,me,p1)
end

-- expanded
on expanded(me,id)
	me._detach(#expanded,me)
end

-- pressed -> string
on pressed(me,id,p1)
	me._detach(#pressed,me,p1)
end
